#include "frame.h"
int iskw(char *s);

void pcenter(WINDOW * win, int x, int y, int width,
	     char *string, chtype color)
{
    int length;
    length = strlen(string);
    length = (width - length - 2) / 2;
    wattron(win, color);
    mvwprintw(win, x, y + length, " %s ", string);
    wattroff(win, color);
    refresh();
}

void labelw(WINDOW * win, char *s, int label_color)
{
    int x, y;
    getmaxyx(win, y, x);
    box(win, 0, 0);
    mvwaddch(win, 2, 0, ACS_LTEE);
    mvwhline(win, 2, 1, ACS_HLINE, x - 2);
    mvwaddch(win, 2, x - 1, ACS_RTEE);
    wattron(win, A_BOLD);
    pcenter(win, 1, 0, x, s, COLOR_PAIR(label_color));
    wattroff(win, A_BOLD);
}

void label(frame z)
{
    if (z->bound) {
	wattron(z->win, z->boxattr);
	box(z->win, 0, 0);
	wattroff(z->win, z->boxattr);
    }
    if (z->label) {
	if (z->flag == 2)
	    pcenter(z->win, z->height - 1, 0, z->width, z->label,
		    z->labattr);
	else
	    pcenter(z->win, 0, 0, z->width, z->label, z->labattr);
    }
}

void text(frame z)
{
    words w;
    int k = 0, flag;
    int l = 2, cpt = 2, tmp;
    w = z->file;
    wmove(z->win, l, 2);
    l++;
    wattron(z->win, z->txtattr);
    while (w) {
	if (w->str)
	    tmp = strlen(w->str);
	else
	    tmp = 1;
	if (cpt + tmp >= z->width) {
	    wmove(z->win, l++, 2);
	    cpt = 2;
	}
	if (w->str) {
	    wattroff(z->win, A_BOLD);
	    wattroff(z->win, A_REVERSE);
	    if (iskw(w->str)) {
		wattron(z->win, A_BOLD);
		if (k == z->pos) {
		    wattron(z->win, A_REVERSE);
		    z->key = w->str;
		}
		k++;
	    }
	    wprintw(z->win, "%s", w->str);
	    wattroff(z->win, A_BOLD + A_REVERSE);
	    cpt += tmp;
	} else {
	    if (cpt > 2 || (w->car != ' ' && w->car != '\'')) {
		wprintw(z->win, "%c", w->car);
		cpt++;
	    }
	}
	w = w->next;
    }
    z->lim = k - 1;
    wattroff(z->win, z->txtattr);
    wattroff(z->win, A_BOLD + A_UNDERLINE);
    wmove(z->win, 1, 2);
}

void term(frame z)
{
    char buf[128];
    words l;
    int x = 1;
    l = z->file;
    wattron(z->win, z->txtattr);
    while (l) {
	snprintf(buf, z->width - 3, "%s", l->str);
	if (buf[0] == '$')
	    x++;
	mvwprintw(z->win, x++, 3, "%s", buf);
	l = l->next;
    }
    wattroff(z->win, z->txtattr);

}

void ascii(frame z)
{
// three white ruhm and may be more
// whyen I wrote this lines. You should
// guess mistakes...
// pvale
    char l, c, w = 0, car;
    FILE *src;
    src = fopen(z->src, "r");
    if (src) {
	while (!feof(src)) {
	    car = fgetc(src);
	    if (isprint(car))
		c++;
	    if (car == '\n') {
		if (c > w)
		    w = c;
		l++;
		c = 0;
	    }
	}

	if (l < z->height) {
	    l = (z->height - l) / 2;
	} else
	    l = 1;

	if (w < z->width) {
	    w = (z->width - w) / 2;
	} else
	    w = 1;
	wmove(z->win, l++, w);
	wattron(z->win, z->txtattr);
	rewind(src);
	while (!feof(src)) {
	    car = fgetc(src);
	    if (car == '\n' || car == EOF) {
		wmove(z->win, l++, w);
	    } else
		wprintw(z->win, "%c", car);
	}
	wattron(z->win, z->txtattr);
	fclose(src);
    } else
	wprintw(z->win, "%s", z->src);

}
