#ifndef FRAME_H
#define FRAME_H
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <ncurses.h>
typedef struct _word_{
  char *str;
  int  car;
  struct _word_ *next;
} enrword, *words;

#define VIM   1
#define LYNX  2
#define SHELL 3

#define RED_PAIR   1
#define GREEN_PAIR 2
#define WHITE_PAIR 3
#define BLUE_PAIR  4

#define YELLOW_PAIR  5
#define CYAN_PAIR  6
#define MAGENTA_PAIR  7

typedef struct _frame_{
  char   *label;
  short  bound, flag;
  short  txtattr, labattr, boxattr;
  int     prog;
  char   *arg;
  char   *plan;
  int    width, height;
  int    x, y;
  int    type;
  char   *txt;
  char   *src;
  words  file;
  int    hidden;
  int    pos, lim;
  char   *key;
  WINDOW  *win;
  struct _frame_ * next;
} enrframe, *frame;
void labelw(WINDOW *win, char* s, int label_color);
void initframe( frame z );
void text(frame z);
void word(char *b, frame z);
void ascii(frame z);
void term(frame z);
void label( frame z );
void pcenter(WINDOW * win, int starty, int startx, int width,
	     char *string, chtype color);
#endif
