
#include "page.h"


page initpage(void)
{
    page res;
    res = calloc(1, sizeof(enrpage));
    res->bound = 1;
    res->width = (nbcols == 0) ? col : nbcols;
    res->height = (nblines == 0) ? row : nblines;
    if (nbcols && nbcols <= col)
	res->y = (col - nbcols) / 2;
    if (nblines && nblines <= row)
	res->x = (row - nblines) / 2;
    res->title = NULL;
    startx = res->x;
    starty = res->y;
    return res;
}

void labels(page p)
{
    if (p->bound) {
	box(p->slide, 0, 0);
	mvwaddch(p->slide, 2, 0, ACS_LTEE);
	mvwhline(p->slide, 2, 1, ACS_HLINE, p->width - 2);
	mvwaddch(p->slide, 2, p->width - 1, ACS_RTEE);
    }
    wattron(p->slide, A_BOLD);
    pcenter(p->slide, 1, 1, p->width, p->title, COLOR_PAIR(1));
    wattroff(p->slide, A_BOLD);
}


void dump(page list)
{
    int count = 0;
    frame aux;
    page head = list;
    do {
	list->num = count++;
	printf("\npage %3d title %s\n", list->num, list->title);
	aux = list->fil;
	while (aux) {
	    printf("\n%s type : %d txt : %s\n", aux->label, aux->type,
		   aux->txt);
	    printf(" %d x %d", aux->width, aux->height);
	    aux = aux->next;
	}
	list = list->next;
    } while (list != head);
}


void inspage(page c, page g)
{
    g->prev->next = c;
    c->prev = g->prev;
    g->prev = c;
    c->next = g;
}
